ML {* add_path "../J" *}

(* Generating an executable compiler *)


theory GenComp = Eval + SystemClasses + AuxLemmas + PreTerm2:

(*
theory GenComp = TranslComp:


lemma [code]: "max_of_list xs = foldr (\<lambda> a b. (if a <= b then b else a)) xs 0"
apply (simp add: max_of_list_def)
apply (rule_tac x=0 in fun_cong)
apply (rule_tac x=xs in fun_cong)
apply (rule_tac x=max and y="(\<lambda>a b. if a \<le> b then b else a)" in arg_cong)
apply (simp add: max_def expand_fun_eq)
done


types_code
  cname ("string")
  vnam ("string")
  mname ("string")
  loc ("int");

consts_code
  "arbitrary" ("(raise ERROR)")
  wf ("true?")

generate_code ("comp.ML") gen = "comp"
*)


declare split_paired_All [simp del]
declare split_paired_Ex [simp del]


  (* ************************************************************ *)


ML {* Syntax.ambiguity_level := 100000 *}

consts
  list_name :: cname
  append_name :: mname
  val_nam :: vnam
  next_nam :: vnam
  l_nam :: vnam
  l1_nam :: vnam
  l2_nam :: vnam
  l3_nam :: vnam
  l4_nam :: vnam

constdefs
  val_name :: vname
  "val_name == VName val_nam"

  next_name :: vname
  "next_name == VName next_nam"

  l_name :: vname
  "l_name == VName l_nam"

  l1_name :: vname
  "l1_name == VName l1_nam"

  l2_name :: vname
  "l2_name == VName l2_nam"

  l3_name :: vname
  "l3_name == VName l3_nam"

  l4_name :: vname
  "l4_name == VName l4_nam"

  list_class :: "java_mb class"
  "list_class ==
    (Object,
     [(val_name, PrimT Integer), (next_name, RefT (ClassT list_name))],
     [((append_name, [RefT (ClassT list_name)]), PrimT Void,
      ([l_name], [],
       If(BinOp Eq ({list_name}(LAcc This)..next_name) (Lit Null))
         Expr ({list_name}(LAcc This)..next_name:=LAcc l_name)
       Else
         Expr ({list_name}({list_name}(LAcc This)..next_name)..
           append_name({[RefT (ClassT list_name)]}[LAcc l_name])), 
       Lit Unit))])"

  example_prg :: "java_mb prog"
  "example_prg == [ObjectC, (list_name, list_class)]"

types_code
  cname ("string")
  vnam ("string")
  mname ("string")
  loc_ ("int")

consts_code
  "new_Addr" ("new'_addr {* %x. case x of None => True | Some y => False *}/ {* None *} {* Loc *}")

  "arbitrary" ("(raise ERROR)")
  "arbitrary" :: "val" ("{* Unit *}")
  "arbitrary" :: "cname" ("\"\"")

  "Object" ("\"Object\"")
  "list_name" ("\"list\"")
  "append_name" ("\"append\"")
  "val_nam" ("\"val\"")
  "next_nam" ("\"next\"")
  "l_nam" ("\"l\"")
  "l1_nam" ("\"l1\"")
  "l2_nam" ("\"l2\"")
  "l3_nam" ("\"l3\"")
  "l4_nam" ("\"l4\"")

ML {*
fun new_addr p none loc hp =
  let fun nr i = if p (hp (loc i)) then (loc i, none) else nr (i+1);
  in nr 0 end;
*}

(*
generate_code ("test_max_spec.ML")
  test2 = "\<lambda> E pe. E \<turnstile> pe \<leadsto> _ :: _"
*)


lemma override_mem [rule_format, simp]:
  "x mem map fst xs \<longrightarrow> (m ++ (map_of xs)) x = (map_of xs x)"
apply (induct xs)
apply (auto simp add: override_def)
done


lemma map_of_override_append [rule_format]:
  "\<forall> xs. map_of (xs @+ ys) = (map_of ys) ++ (map_of xs)"
apply (induct ys)
apply (simp add: expand_fun_eq override_def split add: option.split)

apply (simp (no_asm_simp) only: expand_fun_eq)
apply auto

apply (simp only: map_of_override [THEN sym] del: map_of_override)

apply (case_tac "a = x")
apply (simp del: map_of_override)
apply (case_tac "map_of xs x")
apply (auto simp add: override_def map_of_override [THEN sym] del: map_of_override)
done

lemma unique_override_append [rule_format]: "
  unique ys \<longrightarrow> (\<forall> xs. unique xs \<longrightarrow> unique (xs @+ ys))"
apply (induct ys)
apply (simp add: set_mem_eq  unique_def)+
done


consts
  method_list :: "'c prog \<times> cname \<Rightarrow> ((sig \<times> cname \<times> ty \<times> 'c) list)"
defs 
  method_list_def: "method_list \<equiv> \<lambda>(G,C). class_rec G C [] (\<lambda>C fs ms ts.
                           (map (\<lambda>(s,m). (s,(C,m))) ms) @+ ts)"

lemma method_list_rec_lemma: "
  \<lbrakk> class G C = Some (D,fs,ms); wf ((subcls1 G)^-1) \<rbrakk> \<Longrightarrow>
  method_list (G,C) = (map (\<lambda>(s,m). (s,(C,m))) ms) 
                      @+ (if C = Object then [] else method_list (G,D))"
apply (unfold method_list_def)
apply (simp split del: split_if)
apply (erule (1) class_rec_lemma [THEN trans]);
apply auto
done

lemma map_of_method_list [rule_format]: "wf_prog wf_mb G \<Longrightarrow>
  is_class G C \<longrightarrow> map_of (method_list (G, C)) = method (G, C)"
apply (frule wf_subcls1)

apply (rule_tac a=C in wf_induct) apply assumption
apply (rename_tac C)
apply (intro strip)
apply (case_tac "C = Object")

  (* case  C = Object *)
apply (frule class_Object)
apply (erule exE)+
apply (simp (no_asm_simp) add: method_list_def method_def)
apply (simp only: class_rec_lemma_Object)
apply simp

  (* case C \<noteq> Object *)
apply (subgoal_tac "\<exists> D fs ms. class G C = Some (D, fs, ms)")
apply (erule exE)+
apply (drule_tac x=D in spec)
apply (drule mp) apply (simp add: subcls1I)
apply (subgoal_tac "method (G, C) = method (G,D) ++  (map_of (map (\<lambda>(s,m). (s,(C,m))) ms))")
   prefer 2 apply (rule trans) apply (rule method_rec_lemma) apply assumption+ apply simp
apply (subgoal_tac "method_list (G, C) = (map (\<lambda>(s,m). (s,(C,m))) ms) @+ method_list (G,D)")
   prefer 2 apply (rule trans) apply (rule method_list_rec_lemma) apply assumption+ apply simp
apply (simp only:)
apply (subgoal_tac "is_class G D")
apply (simp (no_asm_simp) add: map_of_override_append)
apply (rule wf_cdecl_supD) 
apply (auto simp: wf_prog_def is_class_def class_def dest: map_of_SomeD)
done


constdefs
  appl_methds_foo :: "'c prog =>  cname => sig => ((ty \<times> ty) \<times> ty list) list"
  "appl_methds_foo G C == \<lambda>(mn, pTs).
     map (\<lambda> ((mn', pTs'), md, rT, mb). ((Class md,rT),pTs'))
     [((mn', pTs'), md, rT, mb) \<in> method_list (G, C). mn = mn' \<and> list_all2 (\<lambda>T T'. G\<turnstile>T\<preceq>T') pTs pTs']"


lemma unique_method_list [rule_format, simp]: 
  "wf_prog wf_mb G  \<Longrightarrow> is_class G C \<longrightarrow> unique (method_list (G, C))"
apply (frule wf_subcls1)

apply (rule_tac a=C in wf_induct) apply assumption
apply (rename_tac C)
apply (intro strip)
apply (case_tac "C = Object")

  (* case  C = Object *)
apply (frule class_Object)
apply (erule exE)+
apply (simp (no_asm_simp) add: method_list_def method_def)
apply (simp only: class_rec_lemma_Object)
apply simp
apply (simp add: wf_prog_def wf_cdecl_def class_def)
apply (subgoal_tac "unique ms")
apply (frule_tac f=id in unique_map_inj) apply (simp add: inj_on_def) apply simp
apply (blast dest: map_of_SomeD)

  (* case C \<noteq> Object *)
apply (subgoal_tac "\<exists> D fs ms. class G C = Some (D, fs, ms)")
apply (erule exE)+
apply (drule_tac x=D in spec)
apply (drule mp) apply (simp add: subcls1I)
apply (subgoal_tac "is_class G D")
apply (subgoal_tac "method_list (G, C) = (map (\<lambda>(s,m). (s,(C,m))) ms) @+ method_list (G,D)")
   prefer 2 apply (rule trans) apply (rule method_list_rec_lemma) apply assumption+ apply simp
apply (simp only:)

apply (subgoal_tac "unique (map (\<lambda>(s, m). (s, C, m)) ms)")
apply (simp add: unique_override_append)
apply (simp add: wf_prog_def wf_cdecl_def class_def)
apply (rule unique_map_inj)
apply (erule conjE)+ apply (erule_tac x="(C, D, fs, ms)" in ballE) apply simp
apply (blast dest: map_of_SomeD)
apply (simp add: inj_on_def)

apply (rule wf_cdecl_supD) 
apply (auto simp: wf_prog_def is_class_def class_def dest: map_of_SomeD)
done

lemma "\<lbrakk> wf_prog wf_mb G; is_class G C \<rbrakk> \<Longrightarrow>
  appl_methds G C (mn, pTs) = set (appl_methds_foo G C (mn, pTs))"
apply (simp add: appl_methds_def appl_methds_foo_def image_def split_beta)
apply (rule set_ext)
apply simp
apply (rule iffI)

apply (auto simp add: map_of_method_list [THEN sym] dest: map_of_SomeD)

apply (subgoal_tac "unique (method_list (G, C))")
apply (frule map_of_SomeI, assumption+)
apply (auto simp add: map_of_method_list)
done


generate_code ("test_max_spec.ML")
  test2 = "\<lambda> G . G\<turnstile>_ \<prec>C1 _"

generate_code ("test_max_spec.ML")
  test2 = "\<lambda> G T. G\<turnstile>T \<preceq> _"

generate_code ("test_max_spec.ML")
  test2 = "appl_methds example_prg Object"

generate_code ("test.ML")
  test2 = "example_prg\<turnstile>Norm (Map.empty, Map.empty)
    -(Expr (l1_name::=NewC list_name))-> _"


generate_code ("tp.ML")
  testtp = "example_env\<turnstile>Norm (Map.empty, Map.empty)
    -(Expr (l1_name::=NewC list_name))-> _"


end
