ML {* add_path "../J" *}

(* Generating an executable compiler *)

theory GenComp = Eval + SystemClasses + AuxLemmas:
(*
theory GenComp = TranslComp:


lemma [code]: "max_of_list xs = foldr (\<lambda> a b. (if a <= b then b else a)) xs 0"
apply (simp add: max_of_list_def)
apply (rule_tac x=0 in fun_cong)
apply (rule_tac x=xs in fun_cong)
apply (rule_tac x=max and y="(\<lambda>a b. if a \<le> b then b else a)" in arg_cong)
apply (simp add: max_def expand_fun_eq)
done


types_code
  cname ("string")
  vnam ("string")
  mname ("string")
  loc ("int");

consts_code
  "arbitrary" ("(raise ERROR)")
  wf ("true?")

generate_code ("comp.ML") gen = "comp"
*)



declare split_paired_All [simp del]
declare split_paired_Ex [simp del]


  (* ************************************************************ *)


ML {* Syntax.ambiguity_level := 100000 *}

consts
  list_name :: cname
  append_name :: mname
  val_nam :: vnam
  next_nam :: vnam
  l_nam :: vnam
  l1_nam :: vnam
  l2_nam :: vnam
  l3_nam :: vnam
  l4_nam :: vnam

constdefs
  val_name :: vname
  "val_name == VName val_nam"

  next_name :: vname
  "next_name == VName next_nam"

  l_name :: vname
  "l_name == VName l_nam"

  l1_name :: vname
  "l1_name == VName l1_nam"

  l2_name :: vname
  "l2_name == VName l2_nam"

  l3_name :: vname
  "l3_name == VName l3_nam"

  l4_name :: vname
  "l4_name == VName l4_nam"

  list_class :: "java_mb class"
  "list_class ==
    (Object,
     [(val_name, PrimT Integer), (next_name, RefT (ClassT list_name))],
     [((append_name, [RefT (ClassT list_name)]), PrimT Void,
      ([l_name], [],
       If(BinOp Eq ({list_name}(LAcc This)..next_name) (Lit Null))
         Expr ({list_name}(LAcc This)..next_name:=LAcc l_name)
       Else
         Expr ({list_name}({list_name}(LAcc This)..next_name)..
           append_name({[RefT (ClassT list_name)]}[LAcc l_name])), 
       Lit Unit))])"

  example_prg :: "java_mb prog"
  "example_prg == [ObjectC, (list_name, list_class)]"

types_code
  cname ("string")
  vnam ("string")
  mname ("string")
  loc_ ("int")

consts_code
  "new_Addr" ("new'_addr {* %x. case x of None => True | Some y => False *}/ {* None *} {* Loc *}")

  "arbitrary" ("(raise ERROR)")
  "arbitrary" :: "val" ("{* Unit *}")
  "arbitrary" :: "cname" ("\"\"")

  "Object" ("\"Object\"")
  "list_name" ("\"list\"")
  "append_name" ("\"append\"")
  "val_nam" ("\"val\"")
  "next_nam" ("\"next\"")
  "l_nam" ("\"l\"")
  "l1_nam" ("\"l1\"")
  "l2_nam" ("\"l2\"")
  "l3_nam" ("\"l3\"")
  "l4_nam" ("\"l4\"")

ML {*
fun new_addr p none loc hp =
  let fun nr i = if p (hp (loc i)) then (loc i, none) else nr (i+1);
  in nr 0 end;
*}

constdefs
  list_all2_exec :: "('a => 'b => bool) => 'a list => 'b list => bool"
  "list_all2_exec P xs ys == length xs = length ys \<and> list_all (split P) (zip xs ys)"

lemma [code]: "list_all2 P xs ys = list_all2_exec P xs ys"
  by (simp add: list_all2_def list_all2_exec_def list_all_conv)

(*
consts_code
  "list_all2" ("\"list_all2_exec\"")
*)

lemma class_rec_lemma_Object [simp]: "wf ((subcls1 G)^-1) \<Longrightarrow> 
  class G Object = Some (D,fs,ms) \<Longrightarrow>
  class_rec G Object t f = f Object fs ms t"
by (rule class_rec_lemma [THEN trans], auto)

(*
constdefs
  override_append :: "'a list => 'a list => 'a list"    (infixr "@+" 65)
  "xs @+ ys == [x:xs . \<not> (fst x) mem (map fst ys)] @ ys"
*)

consts
  override_append :: "('a \<times> 'b) list => ('a \<times> 'b) list => ('a \<times> 'b) list"
                     (infixr "@+" 65)
(*
primrec
  "[] @+ ys = ys"
  "(x#xs) @+ ys = (if ((fst x) mem (map fst ys)) then (xs @+ ys) else (x#(xs @+ ys)))"
*)
primrec
  "xs @+ [] = xs"
  "xs @+ (y#ys) = (if ((fst y) mem (map fst xs)) then (xs @+ ys) else ((xs @ [y]) @+ ys))"


(* a non-standard induction scheme for lists *)
lemma list_induct_snoc [rule_format (no_asm)]: 
"\<lbrakk> (P []); \<forall> a xs. (P xs) \<longrightarrow> P (xs @ [a]) \<rbrakk> \<Longrightarrow> (P xs)"
apply (rule rev_rev_ident [THEN sym [THEN ssubst]])
apply (rule_tac P = "%l. P (rev l)" and list = "rev xs" in list.induct)
apply auto
done

(*
lemma "\<forall> m1 m2. fst a mem map fst ys \<longrightarrow>
        m1 ++ map_of ys = m2 ++ map_of ys"
apply (rule list_induct_snoc)
apply simp
apply (intro strip)
apply (simp add: map_of_override [THEN sym] del: map_of_override)
apply (case_tac "fst a = fst aa")
defer
apply simp
apply (simp (no_asm_simp) add: expand_fun_eq)


apply auto
term option_case
apply (rule fun_cong)
apply (simp add: expand_fun_eq)
thm option_case_def

apply (simp add: expand_fun_eq)

apply (case_tac "fst a = fst aa")
defer
apply (simp)
apply auto
*)



constdefs
  appl_methds_exec :: "'c prog =>  cname => sig => ((ty \<times> ty) \<times> ty list) list"
  "appl_methds_exec G C == \<lambda>(mn, pTs).
    class_rec G C [] (\<lambda> md fs ms ts.
        (map (\<lambda> ((mn', pTs'), rT, mb). ((Class md,rT),pTs'))
            (filter (\<lambda> ((mn', pTs'), rT, mb). 
                       mn = mn' \<and> list_all2 (\<lambda>T T'. G\<turnstile>T\<preceq>T') pTs pTs')
                    ms)) @+ ts)"

lemma appl_methds_exec_lemma : "wf ((subcls1 G)^-1) \<Longrightarrow> class G C = Some (D,fs,ms) \<Longrightarrow>
  appl_methds_exec G C (mn, pTs) = 
       (map (\<lambda> ((mn', pTs'), rT, mb). ((Class C,rT),pTs'))
            (filter (\<lambda> ((mn', pTs'), rT, mb). 
                       mn = mn' \<and> list_all2 (\<lambda>T T'. G\<turnstile>T\<preceq>T') pTs pTs')
                    ms)) @+ 
       (if C=Object then [] else appl_methds_exec G D (mn, pTs))"
apply (unfold appl_methds_exec_def)
apply (simp split del: split_if)
apply (erule (1) class_rec_lemma [THEN trans])
apply auto
done


lemma override_mem [rule_format, simp]:
  "x mem map fst xs \<longrightarrow> (m ++ (map_of xs)) x = (map_of xs x)"
apply (induct xs)
apply (auto simp add: override_def)
done


lemma map_of_override_append [rule_format]:
  "\<forall> xs. map_of (xs @+ ys) = (map_of ys) ++ (map_of xs)"
apply (induct ys)
apply (simp add: expand_fun_eq override_def split add: option.split)

apply (simp (no_asm_simp) only: expand_fun_eq)
apply auto

apply (simp only: map_of_override [THEN sym] del: map_of_override)

apply (case_tac "a = x")
apply (simp del: map_of_override)
apply (case_tac "map_of xs x")
apply (auto simp add: override_def map_of_override [THEN sym] del: map_of_override)
done


lemma set_override_append: "unique ys \<longrightarrow> 
  (\<forall> xs. set (xs @+ ys) = (set xs) \<union> ((set ys) - {y. (fst y) \<in> (fst ` (set xs))}))"
apply (induct ys)
apply simp
apply (simp add: set_mem_eq unique_def)
apply (intro strip)
apply (subgoal_tac "set xs \<union> (insert a (set list) - {y. fst y \<in> fst ` set xs}) = 
  (insert a (set xs \<union> ((set list) - {y. fst y \<in> fst ` set xs})))")
apply (subgoal_tac "(set list - {y. fst y = fst a \<or> fst y \<in> fst ` set xs}) = 
  ((set list - {y. fst y = fst a}) - {y. fst y \<in> fst ` set xs})")
apply (subgoal_tac "set list - {y. fst y = fst a} = set list")
apply (simp only:)
  (* subgoal set list - {y. fst y = fst a} = set list *)
apply (rule subset_antisym)
apply blast 
apply (simp (no_asm_simp) add: set_diff_def subset_def)
apply (intro strip)
apply (subgoal_tac "fst x \<in> fst ` set list")
apply (rule notI)
apply auto
done


lemma blabs:  "wf ((subcls1 G)^-1) \<Longrightarrow> 
  \<forall> D fs ms. (class G C = Some (D,fs,ms)  \<longrightarrow>
       appl_methds G C (mn, pTs) = set (appl_methds_exec G C (mn, pTs)))"
apply (rule_tac a=C in wf_induct) apply assumption
apply (intro strip)
apply (rename_tac C D fs ms)
apply (case_tac "C=Object")

  (* induction base *)
apply (simp (no_asm_simp) add: appl_methds_def appl_methds_exec_def method_def)
apply (simp only: class_rec_lemma_Object)

apply (simp add: split_beta image_def)
apply (rule_tac f=Collect in arg_cong) apply (simp add: expand_fun_eq)

apply (intro strip)
apply (rule iffI)

apply clarify apply simp 
apply (rule_tac x="((mn, pTs'),rT,mb)" in exI)
apply simp
apply (frule_tac "P1.0"="\<lambda> x. x \<in> set ms" and
  "P2.0" = 
  "\<lambda> ((mn, pTs'), md, rT, mb). ((mn, pTs'), rT, mb) \<in> set ms \<and> md = Object"
  in  map_of_map_prop) 
apply blast
apply (simp (no_asm_simp) add: split_beta)
apply (simp add: split_beta)

apply (erule exE)
apply (erule conjE)+

apply (simp (no_asm_simp))
apply (subgoal_tac "(fst xa, snd xa) \<in> set ms")
apply (subgoal_tac "unique ms")
apply (drule map_of_SomeI) apply assumption
apply (simp add: map_of_map)
apply (rule exI) apply (rule surjective_pairing) 
defer				(* unique ms follows from wf_cdecl  *)

apply simp			(* subgoal (fst xa, snd xa) \<in> set ms *)

  (* induction step *)
apply (drule_tac x=D in spec)
apply (drule mp) apply (simp add: subcls1I)
apply (subgoal_tac "\<exists> D' fs' ms'. class G D = Some (D', fs', ms')")
apply (erule exE)+ 
apply ((drule spec)+, drule mp, assumption)
apply (frule_tac mn=mn and pTs=pTs in appl_methds_exec_lemma) apply assumption
apply (simp only:)
apply (simp add: split_beta image_def)
apply (simp (no_asm_simp) add: appl_methds_def)
apply (frule method_rec_lemma) apply assumption
apply (simp only:)
apply simp
apply (subgoal_tac "unique (appl_methds_exec G D (mn, pTs))")
apply (simp only: set_override_append)
apply (simp only: override_Some_iff)
(*
apply (simp add: appl_methds_def)
*)

apply (simp (no_asm_simp) only: conj_disj_distribR)
apply (simp (no_asm_simp) only: conj_disj_distribL)
apply (simp (no_asm_simp) only: ex_disj_distrib)
apply (simp (no_asm_simp) only: Collect_disj_eq)

  (* subgoal B *)
apply (subgoal_tac "{x. \<exists>md rT mb pTs'.
                 x = ((Class md, rT), pTs') \<and>
                 (map_of (map (\<lambda>(s, m). (s, C, m)) ms) (mn, pTs') = None \<and>
                  method (G, D) (mn, pTs') = Some (md, rT, mb)) \<and>
                 list_all2 (\<lambda>T T'. G \<turnstile> T \<preceq> T') pTs pTs'} = 
  (set (appl_methds_exec G D (mn, pTs)) -
           {y. fst y
               \<in> fst `
                 set (map (\<lambda>((mn', pTs'), rT, mb). ((Class C, rT), pTs'))
                       [((mn', pTs'), ab)\<in>ms .
                        mn = mn' \<and> list_all2 (\<lambda>T T'. G \<turnstile> T \<preceq> T') pTs pTs'])})")

  (* subgoal A *)
apply (subgoal_tac "{x. \<exists>md rT mb pTs'.
                 x = ((Class md, rT), pTs') \<and>
                 map_of (map (\<lambda>(s, m). (s, C, m)) ms) (mn, pTs') = Some (md, rT, mb) \<and>
                 list_all2 (\<lambda>T T'. G \<turnstile> T \<preceq> T') pTs pTs'} =
  set (map (\<lambda>((mn', pTs'), rT, mb). ((Class C, rT), pTs'))
                [((mn', pTs'), ab)\<in>ms .
                 mn = mn' \<and> list_all2 (\<lambda>T T'. G \<turnstile> T \<preceq> T') pTs pTs'])")


apply (simp only:)


  (* show subgoal A *)
apply (simp (no_asm_simp) add: image_def split_beta)
apply (rule set_ext)
apply simp
apply (rule iffI)

  apply (erule exE)+
  apply (simp add: map_of_map)
  apply (rule_tac x="((mn,pTs'),rT,mb)" in exI)
  apply (simp add: map_of_SomeD)

  apply (erule exE)+
  apply simp
  apply (rule_tac x="snd (snd xa)" in exI)
  apply (simp (no_asm_simp) only: surjective_pairing [THEN sym])



  (* show subgoal B *)

apply (subgoal_tac "unique ms")
apply (subgoal_tac "(fst xa, snd xa) \<in> set ms")
thm map_of_SomeI
apply (frule_tac l=ms in map_of_SomeI)
apply assumption
thm Map.map_of_mapk_SomeI
thm split_def
apply (rule_tac t=ms and k="fst xa" in Map.map_of_mapk_SomeI)


apply (drule_tac s="appl_methds G D (mn, pTs)" in sym)
apply (simp (no_asm_simp) add: appl_methds_def)
apply (simp (no_asm_simp) add: set_diff_def)
apply (rule set_ext)
apply simp

apply (rule iffI)

  apply (erule exE)+
  apply (simp add: image_def split_beta)
apply (simp add:  map_of_in_set image_compose [THEN sym] comp_def split_beta del: image_compose)

apply (subgoal_tac "\<forall>x. (\<forall>xa. 
  x =  ((Class C, fst (snd xa)), snd (fst xa)) \<longrightarrow>
  ((Class md, rT) = fst x) \<longrightarrow> 
  list_all2 (\<lambda>T T'. G \<turnstile> T \<preceq> T') pTs (snd (fst xa)) \<longrightarrow>
  mn = fst (fst xa) \<longrightarrow>
  xa \<notin>  set ms)")
apply blast
apply (simp)
apply (intro strip)


apply simp
apply (erule conjE)+
apply (simp add:  map_of_in_set image_compose [THEN sym] comp_def split_beta del: image_compose)
apply (subgoal_tac "xa \<in> set ms \<longrightarrow> (fst (fst xa), pTs') \<in>  fst ` set ms")
apply blast
apply (intro strip)

  apply (erule conjE)+
  apply (erule exE)+
  apply simp
  apply (simp add: image_compose [THEN sym] comp_def split_beta del: image_compose)
  apply (simp add: image_def)

done


(fst xa, ?x) \<in> set  (map (\<lambda>(s, m). (s, C, m)) ms)

lemma disjE_asm: "\<lbrakk>P \<or> Q; P \<Longrightarrow> R; \<not> P \<Longrightarrow> Q \<Longrightarrow> R\<rbrakk> \<Longrightarrow> R"
by blast

lemma "[|class G C = Some (D,fs,ms); wf ((subcls1 G)^-1); C \<noteq> Object; unique ms|] ==>
  appl_methds G C (mn, pTs) = 
              {y. \<exists>x. x \<in> set ms \<and>
                  mn = fst (fst x) \<and>
                  list_all2 (\<lambda>T T'. G \<turnstile> T \<preceq> T') pTs (snd (fst x)) \<and>
                  y = ((Class C, fst (snd x)), snd (fst x))}
           \<union> appl_methds G D (mn, pTs)"
apply (simp add: appl_methds_def method_rec_lemma)
apply (simp add: Collect_disj_eq [THEN sym])
apply (frule method_rec_lemma) apply assumption
apply (simp split del: split_if)
apply (rule_tac f=Collect in arg_cong) apply (simp add: expand_fun_eq)
apply (simp add: override_Some_iff)
apply (intro strip)
apply (rule iffI)
apply (erule exE)+
apply simp
apply (erule conjE)+ defer
apply (erule disjE_asm)
apply (erule exE)
apply simp
apply (erule conjE)+
apply (subgoal_tac "(fst xa, snd xa) \<in> set ms")
apply (drule map_of_SomeI) apply assumption
apply (simp add: map_of_map)
apply (rule exI) apply (rule surjective_pairing) 
apply simp			(* subgoal (fst xa, snd xa) \<in> set ms *)

apply simp
apply (erule exE)+
apply simp
apply (rule_tac x=mb in exI)
apply (rule disjI2)
apply (simp (no_asm_simp) add: AuxLemmas.map_of_in_set)
apply (drule_tac x="((mn,pTs'),rT,mb)" in spec)
apply simp
apply (rule notI)
apply simp
thm contrapos_np

apply (drule map_of_SomeI) apply assumption

apply (frule map_of_map_prop)

apply (simp add: ex_disj_distrib [THEN sym])
apply (simp add: conj_disj_distribL [THEN sym])
apply (simp add: conj_disj_distribR [THEN sym])


lemma "[|class G C = Some (D,fs,ms); wf ((subcls1 G)^-1); C \<noteq> Object|] ==>
appl_methds G C (mn, pTs) = {u. \<exists>md rT mb pTs'.
              u = ((Class md, rT), pTs') \<and>
              map_of (map (\<lambda>(s, m). (s, C, m)) ms) (mn, pTs') = Some (md, rT, mb) \<and>
              list_all2 (\<lambda>T T'. G \<turnstile> T \<preceq> T') pTs pTs'} \<union> appl_methds G D (mn, pTs)"
apply (simp add: appl_methds_def method_rec_lemma)
apply (simp add: Collect_disj_eq [THEN sym])
apply (frule method_rec_lemma) apply assumption
apply (simp split del: split_if)
apply (rule_tac f=Collect in arg_cong) apply (simp add: expand_fun_eq)
apply (simp add: override_Some_iff)
apply (simp add: ex_disj_distrib [THEN sym])
apply (simp add: conj_disj_distribL [THEN sym])
apply (simp add: conj_disj_distribR [THEN sym])
apply (intro strip)
apply (rule iffI)
apply blast
oops

(*
apply clarify
apply (rule exI)+
apply (rule conjI, rule HOL.refl)
apply simp
apply auto
{u. \<exists>md rT mb pTs'.
              u = ((Class md, rT), pTs') \<and>
              (map_of (map (\<lambda>(s, m). (s, C, m)) ms) (mn, pTs') = Some (md, rT, mb) \<or>
               map_of (map (\<lambda>(s, m). (s, C, m)) ms) (mn, pTs') = None \<and>
               method (G, D) (mn, pTs') = Some (md, rT, mb)) \<and>
              list_all2 (\<lambda>T T'. G \<turnstile> T \<preceq> T') pTs pTs'} = x
*)

  (* ************** *)


       \<Longrightarrow> {u. \<exists>md rT mb pTs'.
                 u = ((Class md, rT), pTs') \<and>
                 method (G, C) (mn, pTs') = Some (md, rT, mb) \<and>
                 list_all2 (\<lambda>T T'. G \<turnstile> T \<preceq> T') pTs pTs'} =
          {y. \<exists>x. x \<in> set ms \<and>
                  mn = fst (fst x) \<and>
                  list_all2 (\<lambda>T T'. G \<turnstile> T \<preceq> T') pTs (snd (fst x)) \<and>
                  y = ((Class C, fst (snd x)), snd (fst x))} \<union>
          set (appl_methds_exec G D (mn, pTs))

thm appl_methds_def
apply (simp (no_asm_simp) add: method_def)

apply (rule_tac f=Collect in arg_cong) apply (simp add: expand_fun_eq)

apply (intro strip)
apply (rule iffI)

thm is_class_def
apply 
Map.weak_map_of_SomeI: (?k, ?x) \<in> set ?l \<Longrightarrow> \<exists>x. map_of ?l ?k = Some x
apply (intro split)
apply blast
apply (drule_tac x=D in spec)
thm wf_induct
apply (simp add: appl_methds_def appl_methds_exec_def)
apply (simp add: method_def)
thm wf_induct
apply (rule_tac a=C in wf_induct) apply assumption
apply (simp add: class_rec_def wfrec)
thm cut_apply [OF converseI [OF subcls1I]]
apply (erule class_rec_lemma [THEN trans])


appl_methds G C (mn, pTs) = 
{((Class md,rT),pTs') |md rT mb pTs'.
                      method (G,C)  
(if C = Object then empty else method (G,D)) ++  
  map_of (map (\<lambda>(s,m). (s,(C,m))) ms)


(mn, pTs') = Some (md,rT,mb) \<and>
                      list_all2 (\<lambda>T T'. G\<turnstile>T\<preceq>T') pTs pTs'}

  (* ************ *)




generate_code ("test_max_spec.ML")
  test2 = "\<lambda> G . G\<turnstile>_ \<prec>C1 _"

generate_code ("test_max_spec.ML")
  test2 = "\<lambda> G T. G\<turnstile>T \<preceq> _"

generate_code ("test_max_spec.ML")
  test2 = "appl_methds example_prg Object"

generate_code ("test.ML")
  test2 = "example_prg\<turnstile>Norm (Map.empty, Map.empty)
    -(Expr (l1_name::=NewC list_name))-> _"


  (* ************************************************************ *)




generate_code ("tp.ML")
  testtp = "example_env\<turnstile>Norm (Map.empty, Map.empty)
    -(Expr (l1_name::=NewC list_name))-> _"




end
    (* it seems that the following is not correct (and not needed after all) *)
constdefs
  subcls1_list :: "'c prog \<Rightarrow> (cname \<times> cname) list"
  "subcls1_list G == filter (\<lambda> (C,D). C \<noteq> Object) (map (\<lambda> (C, (D, fsms)). (C, D)) G)"

lemma lift_if: "f (if b then e1 else e2) = (if b then (f e1) else (f e2))"
  by simp

lemma foobar: "((C', D', fsms') # G') \<turnstile> C \<prec>C1 D = ((C' = C \<and> D' = D \<and> C' \<noteq> Object) \<or> (D' \<noteq> D \<and> (G'\<turnstile> C \<prec>C1 D)))"
apply (rule iffI)
  (* direction \<Rightarrow> *)
apply (drule subcls1D)
  apply clarify apply (simp add: class_def)
  apply (case_tac "C=C'")
    apply simp+
    apply (erule_tac P="(C, D) \<in> subcls1 G'" in notE) apply (rule subcls1I)
    apply (simp add: class_def)+

      (* direction <= *)
apply (erule disjE)
apply simp apply (rule subcls1I) apply (simp add: class_def)+ apply blast
apply (frule subcls1D)
apply clarify
apply (rule subcls1I)
apply ( simp add: class_def)
apply auto
apply (auto simp add: class_def)

lemma [code]: "G\<turnstile>C \<prec>C1 D = (C,D) mem (subcls1_list G)"
apply (induct G)
apply (simp add: subcls1_list_def)
thm subcls1.cases
(*

\<lbrakk>?a \<in> subcls1 ?G;
   \<And>C D rest. \<lbrakk>?a = (C, D); class ?G C = Some (D, rest); C \<noteq> Object\<rbrakk> \<Longrightarrow> ?P\<rbrakk>
\<Longrightarrow> ?P
*)
apply (rule notI, erule subcls1.cases, simp add: class_def)

apply (subgoal_tac "\<exists> Ca Da fsmsa. a = (Ca, Da, fsmsa)")
  apply (erule exE)+
apply (subgoal_tac "((C, D) mem subcls1_list ((Ca, Da, fsmsa) # list)) =
             (Ca = C \<and> Da = D \<and> Ca \<noteq> Object\<or> (C, D) mem subcls1_list list)")
apply (simp only: foobar)
apply (auto simp add: subcls1_list_def)
done
apply (simp (no_asm_simp) 
  add: subcls1_list_def  map.simps filter.simps split_def fst_conv snd_conv)

apply (simp only: foobar lift_if)
apply (simp only: subcls1_list_def)
apply auto
apply (subgoal_tac "((Ca, Da, fsmsa) # list) \<turnstile> C \<prec>C1 D = ((Ca = C \<and> Da = D \<and> Ca \<noteq> Object) \<or> (list\<turnstile> C \<prec>C1 D))")
prefer 2 thm foobar apply (rule foobar)
apply (simp only: foobar)
apply auto
thm trans
apply (rule_tac s="(Ca = C \<and> Da = D \<and> Ca \<noteq> Object) \<or> (list \<turnstile> C \<prec>C1 D)" in trans)
apply assumption

apply (rule foobar)


apply (simp (no_asm_simp) only: lift_if )
apply (split split_if)
apply (rule conjI)
  apply clarify apply (rule iffI)
     apply (erule subcls1.elims) apply (simp add: class_def)
apply auto



apply
[p\<in>map (\<lambda>p. (fst p, fst (snd p))) list . fst p \<noteq> Object]

apply (simp (no_asm_simp) add: subcls1_list_def split_beta)
